﻿using EJGrid.Models;
using Syncfusion.JavaScript;
using Syncfusion.JavaScript.DataSources;
using Syncfusion.JavaScript.Models;
using System;
using System.Collections;
using System.Collections.Generic;
using System.Data;
using System.IO;
using System.Linq;
using System.Linq.Expressions;
using System.Web;
using System.Web.Mvc;
using System.Web.UI.WebControls;
using System.Xml;
using Syncfusion.Linq;

namespace EJGrid.Controllers
{
    public class HomeController : Controller
    {
        public ActionResult Index()
        {
           
            return View();
        }
       
       public ActionResult DataSource(DataManager dm)
        {
            IEnumerable Data = OrderRepository.GetAllRecords().ToList();
            DataOperations operation = new DataOperations();
            if (dm.Sorted != null && dm.Sorted.Count > 0) //Sorting
            {
                Data = operation.PerformSorting(Data, dm.Sorted);
            }
            if (dm.Where != null && dm.Where.Count > 0) 
            {
                Data = operation.PerformWhereFilter(Data, dm.Where, dm.Where[0].Operator);
            }
            int count = Data.Cast<EditableOrder>().Count();
            if (dm.Select != null)
            {
                Data = operation.PerformSelect(Data, dm.Select);
            }
            if (dm.Skip != 0)
            {
                Data = operation.PerformSkip(Data, dm.Skip);
            }
            if (dm.Take != 0)
            {
                Data = operation.PerformTake(Data, dm.Take);
            }

            return Json(new { result = Data, count = count }, JsonRequestBehavior.AllowGet);
        }
      
        public class DataResult
        {
            public IEnumerable result { get; set; }
            public int count { get; set; }
        }

        
    }
}